#include <stdio.h>
#include <asm/io.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <syslog.h>

int data, n, pid;

void endsignal() {
  data = inb(PORT + 1);
  syslog(LOG_INFO, "watchdog clean stopped!");
  exit(0);
}

int main(int argc, char **argv) {
  printf("WatchDog on port %#3.3x, interval %is, for after %i resets\n", PORT, PAUSE, FORKA);
  printf("(C) V2.00 12.98 Beat Rubischon <beat@rubis.ch>\n");

  if (fork() != 0) exit(0);

  signal(SIGINT, endsignal);
  signal(SIGTERM, endsignal);

  openlog("wdd", LOG_CONS, LOG_DAEMON);
  syslog(LOG_INFO, "watchdog started");

  ioperm(PORT, 2, 1);

  while(1) {
    pid = fork();
    if (pid != 0) {
      syslog(LOG_INFO, "child with pid %i forked", pid);
      wait(NULL);
    }

    else {
      signal(SIGINT, SIG_DFL);
      signal(SIGTERM, SIG_DFL);

      ioperm(PORT, 2, 1);
      for(n = 0; n < FORKA; n++) {
        data = inb(PORT);
        sleep(PAUSE);
      }
      exit(0);
    }
  }
}
